/**
 * <copyright>
 * 
 * Copyright (c) 2014 itemis and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     itemis - Initial API and implementation
 * 
 * </copyright>
 */
package org.eclipse.sphinx.examples.hummingbird20.workflows.util;

import com.google.common.base.Objects;
import java.util.List;
import org.eclipse.core.runtime.OperationCanceledException;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.mwe.core.WorkflowContext;
import org.eclipse.sphinx.emf.mwe.dynamic.IWorkflowSlots;
import org.eclipse.sphinx.emf.resource.ExtendedResource;
import org.eclipse.sphinx.emf.resource.ExtendedResourceAdapterFactory;
import org.eclipse.sphinx.examples.hummingbird20.common.Identifiable;
import org.eclipse.xtext.xbase.lib.InputOutput;

@SuppressWarnings("all")
public class ModelWorkflowExtensions {
  public static List<EObject> getModelSlot(final WorkflowContext ctx) throws OperationCanceledException {
    Object _get = ctx.get(IWorkflowSlots.MODEL_SLOT_NAME);
    final List<EObject> modelSlot = ((List<EObject>) _get);
    boolean _or = false;
    boolean _equals = Objects.equal(modelSlot, null);
    if (_equals) {
      _or = true;
    } else {
      boolean _isEmpty = modelSlot.isEmpty();
      _or = _isEmpty;
    }
    if (_or) {
      InputOutput.<String>println("Model slot is empty, nothing to do!");
      throw new OperationCanceledException();
    }
    return modelSlot;
  }
  
  public static String getLabel(final EObject modelObject) {
    if ((modelObject instanceof Identifiable)) {
      boolean _and = false;
      String _name = ((Identifiable)modelObject).getName();
      boolean _notEquals = (!Objects.equal(_name, null));
      if (!_notEquals) {
        _and = false;
      } else {
        String _name_1 = ((Identifiable)modelObject).getName();
        boolean _isEmpty = _name_1.isEmpty();
        boolean _not = (!_isEmpty);
        _and = _not;
      }
      if (_and) {
        EClass _eClass = ((Identifiable)modelObject).eClass();
        String _name_2 = _eClass.getName();
        String _plus = (_name_2 + " ");
        String _name_3 = ((Identifiable)modelObject).getName();
        return (_plus + _name_3);
      } else {
        EClass _eClass_1 = ((Identifiable)modelObject).eClass();
        String _name_4 = _eClass_1.getName();
        return (_name_4 + " <Unnamed>");
      }
    } else {
      return modelObject.toString();
    }
  }
  
  public static URI getURL(final EObject modelObject) {
    Resource _eResource = modelObject.eResource();
    final ExtendedResource extendedResource = ExtendedResourceAdapterFactory.INSTANCE.adapt(_eResource);
    boolean _notEquals = (!Objects.equal(extendedResource, null));
    if (_notEquals) {
      return extendedResource.getURI(modelObject);
    } else {
      return EcoreUtil.getURI(modelObject);
    }
  }
}
